(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('apollo-link'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define(['exports', 'apollo-link', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global.apollo = global.apollo || {}, global.apollo.rxjs = {}),global.apolloLink.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,apolloLink,rxjs,operators) { 'use strict';

    var __extends = (undefined && undefined.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var RxjsLink = /** @class */ (function (_super) {
        __extends(RxjsLink, _super);
        function RxjsLink(transforms) {
            var _this = _super.call(this) || this;
            _this.onOperation = transforms.onOperation
                ? transforms.onOperation
                : _this.noop;
            _this.onResult = transforms.onResult ? transforms.onResult : _this.noop;
            return _this;
        }
        RxjsLink.prototype.request = function (operation, forward) {
            var operation$ = this.onOperation(rxjs.of(operation));
            var result$ = this.onResult(operation$.pipe(operators.mergeMap(function (op) { return rxjs.from(forward(op)); })));
            return new apolloLink.Observable(function (observer) {
                var sub = result$.subscribe(observer);
                return function () {
                    if (!sub.closed) {
                        sub.unsubscribe();
                    }
                };
            });
        };
        RxjsLink.prototype.noop = function (source) {
            return source;
        };
        return RxjsLink;
    }(apolloLink.ApolloLink));
    function rxjs$1(transforms) {
        return new RxjsLink(transforms);
    }

    exports.RxjsLink = RxjsLink;
    exports.rxjs = rxjs$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bundle.umd.js.map
