import { ApolloLink, Observable as LinkObservable, FetchResult, Operation, NextLink } from 'apollo-link';
import { Observable } from 'rxjs';
export declare type TransformFn<T> = (operation: Observable<T>) => Observable<T>;
export declare type OnOperation = TransformFn<Operation>;
export declare type OnResult = TransformFn<FetchResult>;
export interface Transforms {
    onOperation?: OnOperation;
    onResult?: OnResult;
}
export declare class RxjsLink extends ApolloLink {
    private onResult;
    private onOperation;
    constructor(transforms: Transforms);
    request(operation: Operation, forward: NextLink): LinkObservable<FetchResult>;
    private noop<T>(source);
}
export declare function rxjs(transforms: Transforms): RxjsLink;
