var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ApolloLink, Observable as LinkObservable, } from 'apollo-link';
import { from, of } from 'rxjs';
import { mergeMap } from 'rxjs/operators';
var RxjsLink = /** @class */ (function (_super) {
    __extends(RxjsLink, _super);
    function RxjsLink(transforms) {
        var _this = _super.call(this) || this;
        _this.onOperation = transforms.onOperation
            ? transforms.onOperation
            : _this.noop;
        _this.onResult = transforms.onResult ? transforms.onResult : _this.noop;
        return _this;
    }
    RxjsLink.prototype.request = function (operation, forward) {
        var operation$ = this.onOperation(of(operation));
        var result$ = this.onResult(operation$.pipe(mergeMap(function (op) { return from(forward(op)); })));
        return new LinkObservable(function (observer) {
            var sub = result$.subscribe(observer);
            return function () {
                if (!sub.closed) {
                    sub.unsubscribe();
                }
            };
        });
    };
    RxjsLink.prototype.noop = function (source) {
        return source;
    };
    return RxjsLink;
}(ApolloLink));
export { RxjsLink };
export function rxjs(transforms) {
    return new RxjsLink(transforms);
}
//# sourceMappingURL=index.js.map